Category
class Category extends Category
Class Category
Traits
Constants
| EVENT_MODEL_AFTER_SAVE |
|
| EVENT_MODEL_BEFORE_SAVE |
|
| EVENT_MODEL_BEFORE_DELETE |
|
| EVENT_MODEL_AFTER_DELETE |
|
| FIELD_IS_NULL |
$this->find_by_field(Model::IS_NULL) |
Properties
| Controller read-only | $mod | from AuditableTrait | |
| protected string|null | $model_name | from Model | |
| string read-only | $table_name | from AuditableTrait | |
| protected bool | $table_use_group_id | from Category | |
| protected bool | $table_auto_properties | from Category | |
| protected string | $table_primary_key | from Model | |
| protected array | $table_primary_compound_key | from Model | |
| array read-only | $properties | from AuditableTrait | |
| protected array | $properties_meta | from Model | |
| protected array | $markers | from Model | |
| bool|string | $class_name | from Model | |
| string | $render_type | from Model | |
| protected int | $model_version | Hint your model version, this parameter might affect certain outcomes and behaviours This version string is added for backwards compatibility |
from Model |
| protected string | $model_default_render_xui | from Category | |
| protected array | $render_params | Parameters that will be consigned to the XUI helper |
from Model |
| static string | $find_by_separators | from Model | |
| bool | $loaded | from Model | |
| bool | $saved | from Model | |
| protected array | $changed | from Model | |
| array | $cache_function_result | from Model | |
| static array | $_request_cache | from Model | |
| static protected bool | $auditingDisabled | Is auditing disabled? |
from AuditableTrait |
| protected | $auditExcludedProperties | from AuditableTrait | |
| static bool | $silent_mode | from DocumentModel | |
| protected array | $_update_document_index | from DocumentModel | |
| protected DocumentIndex|null | $documentIndex | from DocumentModel | |
| DocumentIndexReference | $rights_context | A document that can be used for accessing this document. Their must either be a reference between the rights_context and the document or the can_read of the document must actually evalute the rights context. |
from DocumentModel |
| static protected Category[][] | $rights_context_categories | from Category | |
| static protected array | $tree | from Category | |
| bool deprecated | $duplicate | This is coming from group template init |
from Category |
Methods
Magic Function Object Cloning Make sure object references are cleaned up as each object requires a clean and separate reference
Calls the passed function only if it is not cached yet, otherwise the previous cached result will be returned
Global named scope scopeAll to use on models to return an unscoped unloaded collection
Called for scopeby Magic Function Creates a new ModelCollection and applies the passed scope
Called for scope_ Magic Function Creates a new ModelCollection and applies the passed custom scope function
No description
Attaches a file, creating a document within this category
Apply lib->format multi_format on passed property. The result will be written to ->[property]_formatted
Adds a condition to scope the following find functions
Returns if current user can read this category
Returns whether this model should allow related comments or not. The user can still be denied comments when the comments policy "write" is not given to the user.
Checks whether this model can be commented on.
This function checks wether this document can be read by the logged in user and takes the full hierarchy (parent instances) and all possible rights contexts into account
Evaluates can_read_global inside a specific rights context
Checks whether this document can be linked with read reference.
Can see defaults to can_read_global, but can be overridden by supporting modules (e.g. closed group should be visible but not readable)
Returns whether this model should allow to create comments or not. The user can still be denied to write comments when the comments policy "write" is not given to the user.
This function checks wether this document can be read by the logged in user and takes the full hierarchy (parent instances) and all possible rights contexts into account
Evaluates can_write_global inside a specific rights context
Clears the cache for all functions or a specific one
Returns the count of all models with the specific column value
Creates a category for the instance in the xfs root category
Decreases the size of this and all affected folders.
on the desired collection.
Disables the silent mode Objects in silent mode do not cause document index job queues, thus saving them is much more performant but does not update the search index, the wall or other similar system modules
Sets the silent mode to true Objects in silent mode do not cause document index job queues, thus saving them is much more performant but does not update the search index, the wall or other similar system modules
Evaluates the first possible template ID from the category (and parent categories) and returns it.
Get Document by using the uuid
Find Function to find models using the passed condition
Returns loaded ModelCollection
No description
No description
No description
No description
Returns all models with a specific column value. Query params can be e.g. order_by
Converts a findby* function name to SQL query.
Get the (Auditable) properties excluded from audit.
Get the auditable properties to include in audit Defaults to all attributes in the DB Schema
Get the last auditTrail records for current Model
Return properties which have been changed after model was initialized/loaded We know these values have been changed locally, but these changes are NOT necessarily reflecting the DB diff
No description
Returns a list of all property name variants for all languages, e.g. "title_i18n" -> "title_i18n, title_DE_DE, title_EN_EN"
Gets an I18nToken for a model property (e.g. title_i18n)
Returns the Query object which is being used for building the query The function creates a new Query object if required to enable lazy loading
Return properties which have been touched/set after model was initialized/loaded We know these values have been set, but they might not have changed
Lookup Category ID
No description
Function designed to work well with cat_selector form elements
Function designed to work well with cat_selector form elements
recursive function, returns all child ids of category
Returns all properties which are available as DB field (= can be used as find_by() properties) with its currently known raw value Please note that smartTimeFields (updated_at, created_at) are not converted to mysql-date format
Return the information from the document registry This information contains additional meta data as well as relational information
Returns the path for this documents storage path This folder is automatically cleared when the document is removed
Return the property translated property value if available
Returns the SQL table of this model (if available)
Returns an array of ancestor categories tree arrays for this category.
No description
Returns if the silent mode is currently active Objects in silent mode do not cause document index job queues, thus saving them is much more performant but does not update the search index, the wall or other similar system modules
Gets all Child-Categories of this Category, with the same Group-Context (important for Root-Categories)
No description
will determine a new folder name, which isn't set in the same parent-Category
Returns an instance specific category as system folder from system dms.
Does this model represent an existing database record? (can be updated)
Increases the size of this and all affected folders.
Checks if the current category has a name-duplicate in its parent-category.
Returns whether this category is one of a personal workspace folder.
Recursively creates categories.
Automatically recover document index if document model is restored
Function to parse a property which is supposed to contain id references
No description
Checks the policies of the current folder and saves the information as bit in has_policy property
Registers the passed scope as default scope A default scope is present when the model is being loaded and can be removed using the unscope() function if required The passed scope must be defined in a scope[SCOPE_NAME] function e.g. scopeGroupId
removes index-entry of this model (only marking to delete).
Resolves the category id, taking into consideration potential rights context prefixes.
Resolve the link of a category Return the category itself if it isn't a link
Loads the rights context by checking all possible rights context and return it without apply on this model.
Provides a list of all values allowed for enumerations.
No description
Returns unloaded ModelCollection
Sets the related document index.
Set a Property. If $property_id is an array and $property_value is false, set_property is called for each element in the array with the array key and value as params.
Sets parameter that will be passed to the XUI helpers
Sort this element to a specific position
Decrease Sort Priority (Increases SORT value)
Increase Sort Priority (Decreases SORT value)
Temporarily disable the use of the group ID in all queries made
Returns an XML of all model properties
TBD: Move this method to the audit model? and keep things slim in trait?
Returns an unscoped Collection
updates the related index-item for itself (not global, only for this model!)
Update the sort property for a given table (Move a record up/down)
checks for a policy in this category-context
Details
in
Model at line 1117
ModelCollection|Model|Model[]|int
__call(string $method, array $args = array())
No description
in
Model at line 1684
__clone()
Magic Function Object Cloning Make sure object references are cleaned up as each object requires a clean and separate reference
in
Model at line 146
__construct(int|bool $id = false)
No description
in
Model at line 1093
mixed
__get(mixed $var)
No description
in
Model at line 1743
__isset($name)
No description
in
Model at line 1695
string
__toString()
String Representation of this object (calls for render method)
in
Model at line 1155
mixed
_call_cached_function(string $function, array $args)
Calls the passed function only if it is not cached yet, otherwise the previous cached result will be returned
in
ScopesTrait at line 100
Query
_scopeAll(Query $Query)
Global named scope scopeAll to use on models to return an unscoped unloaded collection
in
ScopesTrait at line 111
Query
_scopeDefault(Query $Query)
Load default scopes
in
ScopesTrait at line 143
protected ModelCollection
_scope_by(string $fn, array $parameters)
Called for scopeby Magic Function Creates a new ModelCollection and applies the passed scope
in
ScopesTrait at line 159
protected ModelCollection
_scope_custom(string $scopeName, Query|null $Query = null)
Called for scope_ Magic Function Creates a new ModelCollection and applies the passed custom scope function
in
AuditableTrait at line 97
AuditTrail|null
addAuditTrail(string $event = AuditableInterface::AUDIT_EVENT_MISC, string|null $customMessage = null)
No description
in
Category at line 1081
add_category($name)
Creates a sub directory from a given name
in
Category at line 1114
add_file(DocumentIndex $xfs_document_index)
Attaches a file, creating a document within this category
in
Model at line 954
add_formatted_property(string $property, string $format, array $options = array())
Apply lib->format multi_format on passed property. The result will be written to ->[property]_formatted
in
ScopesTrait at line 34
ModelCollection
add_scope_condition(Condition|ConditionGroup|Query|string $new_condition)
Adds a condition to scope the following find functions
in
Model at line 40
Model[]
all(mixed $params = ['order_by'=>'COL1)
Return all models
in
Category at line 517
bool
can_delete(int $id = null)
No description
in
Category at line 328
bool
can_read(int $id = null, bool $skip_system_folder_check = false)
Returns if current user can read this category
in
DocumentModel at line 429
bool
can_read_comments()
Returns whether this model should allow related comments or not. The user can still be denied comments when the comments policy "write" is not given to the user.
in
DocumentModel at line 451
final bool
can_read_comments_global(bool $return_hidden = false)
Checks whether this model can be commented on.
in
DocumentModel at line 361
final bool
can_read_global($return_hidden = false)
This function checks wether this document can be read by the logged in user and takes the full hierarchy (parent instances) and all possible rights contexts into account
in
DocumentModel at line 413
bool
can_read_global_in_rights_context(DocumentIndexReference|false $rights_context = false)
Evaluates can_read_global inside a specific rights context
in
DocumentModel at line 795
bool
can_reference()
Checks whether this document can be linked with read reference.
This method also considers the group context and parent context of the mod owns this document to apply module specific reference policies.
in
DocumentModel at line 770
bool
can_see()
Can see defaults to can_read_global, but can be overridden by supporting modules (e.g. closed group should be visible but not readable)
in
DocumentModel at line 498
bool
can_share()
deprecated
deprecated
Returns true if this document can be shared with groups or users.
This method can be overridden by subclass.
in
Category at line 388
bool
can_write(int|bool $id = false)
Returns if current user can write this category
in
DocumentModel at line 439
bool
can_write_comments()
Returns whether this model should allow to create comments or not. The user can still be denied to write comments when the comments policy "write" is not given to the user.
in
DocumentModel at line 508
final bool
can_write_global($return_hidden = false)
This function checks wether this document can be read by the logged in user and takes the full hierarchy (parent instances) and all possible rights contexts into account
in
DocumentModel at line 546
bool
can_write_global_in_rights_context(DocumentIndexReference $rights_context)
Evaluates can_write_global inside a specific rights context
in
Model at line 1174
clear_cached_functions(string|bool $function = false)
Clears the cache for all functions or a specific one
in
Model at line 616
clear_properties()
No description
in
Model at line 40
int
count_all() $eturns the count of all models, see $this->find('count')
No description
in
Model at line 40
int
count_by_TABLE_COL_and_TABLE_COL2(mixed $COL1_VALUE, mixed $COL2_VALUE)
Returns the count of all models with the specific column value
in
Category at line 1340
Category
create_xfs_category(string $instance_id)
Creates a category for the instance in the xfs root category
in
Model at line 939
string|void
debug(bool $show_markers = false, int $mode = 0)
No description
in
Category at line 1329
decrease_folder_size(int $size, int|null $updated_at = null, null|Category $target_category = null)
Decreases the size of this and all affected folders.
If the file was moved from one in another folder, the target category (structure) will be used to determine the folders that are not affected of the size calculation.
in
Category at line 220
bool
delete(int|string $limit = 'auto')
Delete Category
in
Model at line 40
int
delete_by_TABLE_COL(mixed $COL_VALUE) Delete rows specified by condition and returns the affected rows. NOTE: This does not trigger a delete() function of the model. If required use pluck('delete')
on the desired collection.
in
DocumentModel at line 71
void
disable_silent_mode()
Disables the silent mode Objects in silent mode do not cause document index job queues, thus saving them is much more performant but does not update the search index, the wall or other similar system modules
in
Model at line 1642
void
disable_table_group_id()
Disable the use of the group ID in all queries made
in
DocumentModel at line 60
void
enable_silent_mode()
Sets the silent mode to true Objects in silent mode do not cause document index job queues, thus saving them is much more performant but does not update the search index, the wall or other similar system modules
in
Model at line 1667
void
enable_table_group_id()
Enable the use of the group ID in all queries made
in
Category at line 1411
int
evaluateTemplateId()
Evaluates the first possible template ID from the category (and parent categories) and returns it.
This method takes into account, that the inheritance chain might be broken and, therefore, returns 0. Returns null if something went wrong with fetching the category (and potential parent categories).
in
DocumentModel at line 125
static DocumentModel|null
fetchByUuid(string $uuid, bool $ignoreCanReadRights = false)
deprecated
deprecated
Get Document by using the uuid
in
Category at line 1122
fill_structure(Category[]|array $category_lookup = null, bool $auto_save = true)
No description
in
Model at line 1218
ModelCollection|Model|int|null
find(string $mode = 'all', Condition|ConditionGroup|Query|string|array $conditions = false, array|null $query_params = null)
Find Function to find models using the passed condition
in
Model at line 40
ModelCollection|Model[]
find_all_by_TABLE_COL_and_TABLE_COL2($COL1_VALUE, $COL2_VALUE, $params=['order_by'=>'COL1, 5]] $)
Returns loaded ModelCollection
in
Category at line 39
Category[]
find_all_by_group_id(int|int[] $group_id, mixed $query_params)
No description
in
Category at line 39
Category[]
find_all_by_group_id_and_pid(int|int[] $group_id, int|int[] $pid, mixed $query_params)
No description
in
Category at line 39
Category[]
find_all_by_pid(int $id)
No description
in
Category at line 39
Category[]
find_all_by_pid_and_group_id(string $pid, int $group_id, array $options = [])
No description
in
Category at line 39
Category[]
find_all_by_reference_id(int $reference_index_id)
No description
in
Category at line 39
Category[]
find_all_by_structure(string|string[] $group_id, mixed $query_params)
No description
in
Category at line 39
Category[]
find_all_by_system_folder(int $int)
No description
in
Model at line 40
Model
find_by_TABLE_COL(mixed $COL_VALUE, mixed $params = ['order_by'=>'COL1)
Returns all models with a specific column value. Query params can be e.g. order_by
in
Category at line 39
Category
find_by_foldername_and_pid(mixed $sub_folder, int $id)
No description
in
Category at line 39
Category
find_by_xfs_source(mixed $xfs_source, mixed $query_params)
No description
in
Model at line 1402
protected Query
functionNameToQuery(string $query, array $parameters)
Converts a findby* function name to SQL query.
in
AuditableTrait at line 166
array
getAuditEvents()
Get audit events
in
AuditableTrait at line 220
array
getAuditExcludeProperties()
Get the (Auditable) properties excluded from audit.
Defaults to primary_key and timestamps
in
AuditableTrait at line 199
array
getAuditIncludeProperties()
Get the auditable properties to include in audit Defaults to all attributes in the DB Schema
in
AuditableTrait at line 183
AuditTrail[]|ModelCollection
getAuditTrail(int $limit = 50)
Get the last auditTrail records for current Model
in
Model at line 1857
array
getChangedProperties(bool $returnOldValues = false)
Return properties which have been changed after model was initialized/loaded We know these values have been changed locally, but these changes are NOT necessarily reflecting the DB diff
in
Model at line 970
ModelCollection
getCollectionByQuery(string $model_name, array|string $dbquery_result, string $population_mode = 'full', string $post_fill_function = 'update')
No description
in
Model at line 191
array
getDBSchema(string $field = null)
Get DB Schema if available
in
Model at line 1806
string[]
getI18nPropertyVariants($propertyName, $localeAsKey = false)
Returns a list of all property name variants for all languages, e.g. "title_i18n" -> "title_i18n, title_DE_DE, title_EN_EN"
in
Model at line 1914
I18nTokenHelper
getI18nTokenForProperty(string $i18nProperty, int|null $limitString = null)
Gets an I18nToken for a model property (e.g. title_i18n)
in
DocumentModel at line 49
Controller
getMod()
No description
in
Category at line 39
CategoryCollection
getModelCollection()
No description
in
Model at line 334
int|null
getPrimaryKeyValue()
Get the primary id (post_id) for this model
in
Model at line 492
array
getPropertyMarkers(bool $value_discovery = true)
Return properties and markers
in
ScopesTrait at line 217
Query
getScopeQuery(bool $applyDefaultScopes = true)
Returns the Query object which is being used for building the query The function creates a new Query object if required to enable lazy loading
in
Model at line 1827
array
getTouchedProperties(bool $returnOldValues = false)
Return properties which have been touched/set after model was initialized/loaded We know these values have been set, but they might not have changed
in
Category at line 684
array|bool
get_categories_by_pid($pid = 0, bool $sort_by_name = false)
Lookup Category ID
in
Category at line 714
array
get_category_dyn_tree(array $params = [])
Get categories for navigation
in
Category at line 818
array
get_category_tree(Category $parent = null, int $levels = null, bool $with_objects = true, bool $hide_system_folders = true, string $sec_level = 'read')
No description
in
Category at line 753
array
get_catselect_tree()
Function designed to work well with cat_selector form elements
in
Category at line 762
array
get_catselect_tree_write()
Function designed to work well with cat_selector form elements
in
DocumentModel at line 882
DocumentItem
get_cf()
Return the cf library for this model type
in
Category at line 1051
array
get_child_ids(int|bool $start_id = false)
recursive function, returns all child ids of category
in
Model at line 1611
string
get_created_at_formatted()
Return a Formatted DateTime
in
Model at line 520
array
get_db_properties()
Returns all properties which are available as DB field (= can be used as find_by() properties) with its currently known raw value Please note that smartTimeFields (updated_at, created_at) are not converted to mysql-date format
in
Category at line 1224
Category
get_default_category()
Returns the default category for the current folder
in
DocumentModel at line 135
DocumentIndex|null
get_document_index()
Returns the related document index.
in
DocumentModel at line 826
DocumentRegistry|null
get_document_registry_info()
Return the information from the document registry This information contains additional meta data as well as relational information
in
DocumentModel at line 243
get_document_tmp_folder()
Returns the path for this documents storage path This folder is automatically cleared when the document is removed
in
Category at line 643
ModelCollection|Document[]
get_documents()
get related documents of this category
in
Model at line 1784
bool|mixed
get_i18n_property(string $property, string $force_language = false)
Return the property translated property value if available
in
Model at line 351
string|null
get_model_name()
Returns the SQL table of this model (if available)
in
Model at line 312
string|bool
get_model_table_name(string $table_name = null)
Returns the SQL table of this model (if available)
in
Category at line 906
array
get_parent_categories(int $limit = 10, bool $category_id_path = false)
Returns an array of ancestor categories tree arrays for this category.
These tree arrays contain all information relative for building a dyn tree.
in
Category at line 1095
string
get_path(bool $category_id = false, string $separator = '/', bool $leadingSeparator = true)
No description
in
Model at line 474
array
get_properties(bool $value_discovery = true)
Returns the complete properties array
in
Model at line 508
array
get_properties_meta(?string $field = null)
No description
in
Model at line 434
mixed
get_property(string|null $property_id, bool $get_raw_value = false)
No description
in
Model at line 1772
static mixed|null
get_request_cache(string $key)
Return Cache Entry if it exists
in
DocumentModel at line 82
bool
get_silent_mode()
Returns if the silent mode is currently active Objects in silent mode do not cause document index job queues, thus saving them is much more performant but does not update the search index, the wall or other similar system modules
in
Category at line 316
Category[]|ModelCollection|null
get_sub_categories()
Gets all Child-Categories of this Category, with the same Group-Context (important for Root-Categories)
in
Model at line 303
string|null
get_table_name()
Returns the table name of this model.
in
Model at line 325
string|null
get_table_primary_key()
No description
in
Category at line 80
string|int
get_thumbnail_document(bool $force_new = false)
No description
in
Category at line 773
mixed
get_tree_data(Category|null $parent = null, int $levels = 0, bool $hideSystemFolders = true)
No description
in
Category at line 625
string
get_uniqe_foldername(string $old_name = 'unnamed')
will determine a new folder name, which isn't set in the same parent-Category
in
Model at line 1620
string
get_updated_at_formatted()
Return a Formatted DateTime
in
Category at line 1361
Category
get_xfs_instance_category($instance_id)
Returns an instance specific category as system folder from system dms.
If the category is not exists, it will be create.
in
DocumentModel at line 852
Document|null
get_xui_document()
Get XUI Document Representation
in
Category at line 293
void
handle_reference_delete(DocumentIndexReference $ref, $user_id = null)
No description
in
Model at line 1868
bool
hasChangedProperties()
No description
in
Model at line 807
bool
hasExistingDatabaseRecord()
Does this model represent an existing database record? (can be updated)
in
Model at line 1835
bool
hasTouchedProperties()
Returns true if at least one property is marked as changed
in
Category at line 1316
increase_folder_size(int $size, int|null $updated_at = null, null|Category $source_category = null)
Increases the size of this and all affected folders.
If the file was moved from one in another folder, the source category (structure) will be used to determine the folders that are not affected of the size calculation.
in
Model at line 210
init(bool $auto_load = true)
Initializes the model
in
AuditableTrait at line 43
initAuditableTrait()
Init Method
in
AuditableTrait at line 233
bool
isAuditingEnabled()
Determine whether auditing is enabled.
Defaults to true for Frontend/UI Actions and false for CLI/Console Actions
in
Category at line 1284
bool
is_from_share()
No description
in
Category at line 97
bool
is_name_in_category(string $name = '')
Checks if the current category has a name-duplicate in its parent-category.
Will check other categories (AND other documents if this has no file-extension)
in
Category at line 1040
bool
is_parent_of($category_id)
No description
in
Category at line 1253
bool
is_personal(bool $user_id = false)
Returns whether this category is one of a personal workspace folder.
in
Category at line 1266
bool
is_personal_root(bool $user_id = false)
No description
in
Category at line 1277
bool
is_share_root()
No description
in
Model at line 390
load()
No description
in
Model at line 837
protected bool
load_from_db(string $table_name = null, array $key_fields = [])
No description
in
Category at line 986
int
mkcat($category_path, $target_category_id = 0, $path_split = '/', $path_name_friendly = false)
Recursively creates categories.
in
DocumentModel at line 932
void
onRestore()
Automatically recover document index if document model is restored
in
Category at line 1441
SearchIndexRecord
onSearchIndexUpdate(SearchIndexRecord $searchIndexRecord)
Adds the Category to the search index
in
DocumentModel at line 943
static array
parseIdRefProperty(mixed $documentIndexValues = null)
Function to parse a property which is supposed to contain id references
in
Model at line 1062
ModelCollection|Model[]
populate_model_by_query(string $model_name, array|string $dbquery_result, string $population_mode = 'full', string $post_fill_function = 'update')
deprecated
deprecated
No description
in
Category at line 1018
refresh_policy_info()
Checks the policies of the current folder and saves the information as bit in has_policy property
in
ScopesTrait at line 127
protected void
registerDefaultScope($scopeName)
Registers the passed scope as default scope A default scope is present when the model is being loaded and can be removed using the unscope() function if required The passed scope must be defined in a scope[SCOPE_NAME] function e.g. scopeGroupId
in
Model at line 161
reload_schema()
Reloads the schema of the model
in
DocumentModel at line 230
final
remove_document_index()
removes index-entry of this model (only marking to delete).
the real delete operation will be triggered by the document_index_deamon. (will be automatically trigged at: DocumentModel->delete())
in
DocumentModel at line 259
protected bool
remove_from_db(string $table_name, array $key_fields = null)
No description
in
DocumentModel at line 841
string|null
render()
Generic Renderer
in
DocumentModel at line 350
static void
resetRightsCache(int $document_index_id)
No description
in
ScopesTrait at line 231
void
resetScopeQuery()
Reset Scope to null
in
Category at line 1170
Category
resolve_category_id(mixed $category_id, bool $resolve_link_itself = false, bool $return_default = true)
Resolves the category id, taking into consideration potential rights context prefixes.
The prefix usually identifies an actual object in the current module. The suffix either is empty for direct access or provides the local id of an object below the linked category
in
Category at line 1146
Category|DocumentModel|false
resolve_link()
Resolve the link of a category Return the category itself if it isn't a link
in
DocumentModel at line 739
DocumentIndexReference|null
resolve_rights_context(null|string $right = null, bool $apply = false)
Loads the rights context by checking all possible rights context and return it without apply on this model.
in
Category at line 137
int|bool
save(bool $notify_parent_of_change = true)
Save Changes
in
Model at line 633
protected int|bool
save_to_db(string $table_name, array $params = array())
No description
in
Model at line 1381
bool|array
schema_values(mixed $field_name)
Provides a list of all values allowed for enumerations.
Returns FALSE if the field in question does not exist Returns TRUE for non enum fields Returns an array for enum fields with all available values
in
ScopesTrait at line 81
ModelCollection
scope(string $scopeName, Query|null $scopeQuery = null)
No description
in
ScopesTrait at line 16
ModelCollection
scopeAll()
No description
in
Model at line 40
Model[]
scope_by_TABLE_COL_and_TABLE_COL2(mixed $COL1_VALUE, mixed $COL2_VALUE)
Returns unloaded ModelCollection
in
ScopesTrait at line 16
ModelCollection
scope_by_id(int|array $id)
No description
in
Category at line 657
int
search_category_id_by_name($name, int $pid = 0)
Lookup Category ID
in
Model at line 40
void
self() $this find_by_id($id)
No description
in
DocumentModel at line 148
setDocumentIndex(DocumentIndex|null $documentIndex)
Sets the related document index.
in
ScopesTrait at line 88
void
setModelCollectionReference(ModelCollection $modelCollectionReference)
No description
in
Category at line 1474
void
set_name_i18n($name)
No description
in
Model at line 599
void
set_properties_from_array(array $input, array|bool $filter = false)
No description
in
Model at line 540
set_property(string|array $property_id, mixed $property_value = false, bool $no_change = false)
Set a Property. If $property_id is an array and $property_value is false, set_property is called for each element in the array with the array key and value as params.
in
Model at line 1716
set_render_params(mixed $params = array())
Sets parameter that will be passed to the XUI helpers
in
Model at line 1756
static
set_request_cache(string $key, mixed $value)
Set Request Cache Entry
in
SortTrait at line 116
void
sortMoveTo(int $id, int $sortTo, array|null $conditions = [])
Sort this element to a specific position
in
SortTrait at line 28
sort_down(int $steps = 1, $params = array())
Decrease Sort Priority (Increases SORT value)
in
SortTrait at line 17
sort_up(int $steps = 1, $params = array())
Increase Sort Priority (Decreases SORT value)
in
Model at line 1675
stop_temporary_group_id_overwrite()
Stops the temporary overwrite of the table_group_id
in
Model at line 1657
void
temporarily_disable_table_group_id()
Temporarily disable the use of the group ID in all queries made
in
Model at line 1583
string
to_json()
Returns the model as JSON array
in
Model at line 1594
string
to_string()
Returns the model as STRING
in
Model at line 1536
string
to_xml(array|bool $property_filter = false, bool|DOMDocument $doc = false, DOMElement $parent_element = null)
Returns an XML of all model properties
in
Model at line 1843
void
touchProperty($propertyName)
No description
in
AuditableTrait at line 59
triggerAuditEvent(Model $model, string $eventKey = AuditableInterface::OBSERVE_EVENT_SAVE)
TBD: Move this method to the audit model? and keep things slim in trait?
in
ScopesTrait at line 56
ModelCollection
unscope(string $scopeName = null, Query|null $scopeQuery = null)
Returns an unscoped Collection
in
DocumentModel at line 159
final bool
update_document_index(string $status = IndexEventInterface::EVENT_UPDATE)
updates the related index-item for itself (not global, only for this model!)
in
SortTrait at line 43
protected int
update_sort(mixed $id = false, string $direction = 'up', int $steps = 1, array $params = array())
Update the sort property for a given table (Move a record up/down)
in
Category at line 447
string
user_has_tree_policy(string $policy, bool $id = false, DocumentIndexReference $rights_context = null)
checks for a policy in this category-context
in
Category at line 545
string|true
validate(array $fieldErrors)
No description